Sign in Start for free

Releases

List all of the releases that belong to the given Channel

GET /api/{spaceId}/channels/{id}/releases

Also reachable at /api/channels/{id}/releases, /api/spaces/{spaceIdentifier}/channels/{id}/releases.

Releases will be ordered from most recent to least recent,

Path Parameters

  • id string (required)
    ID of the Channel to get Releases for.
  • spaceId string (required)
    ID of the Space to which the given Channel belongs.

Query Parameters

  • projectId string
    ID of the Project to which the given Channel belongs.
  • searchByVersion string
    A partial version, to limit the set of Releases to those with a version that includes the partial version.
  • skip integer
    Number of items to skip. Defaults to zero. Minimum 0.
  • take integer
    Number of items to take. Defaults to 30. Minimum 0.

Response

200 — List of Releases on the given Channel.

  • Id string
    Gets or sets a unique identifier for this resource.
  • ItemType string
  • Items array of object
    • Assembled string
      Format date-time.
    • BuildInformation array of object
    • ChannelId string
    • CustomFields object
    • Id string
      Gets or sets a unique identifier for this resource.
    • IgnoreChannelRules boolean
    • LastModifiedBy string
      Gets or sets the username of the user who last modified this resource.
    • LastModifiedOn string
      Gets or sets the date/time that this resource was last modified. Format date-time.
    • LibraryVariableSetSnapshotIds array of string
      Snapshots of the project’s included library variable sets. The snapshots are VariableSetResources, not LibraryVariableSetResources.
    • Links object
      Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
    • ProjectDeploymentProcessSnapshotId string
    • ProjectId string
    • ProjectVariableSetSnapshotId string
    • ReleaseNotes string
    • SelectedGitResources array of object
    • SelectedPackages array of object
    • SpaceId string
    • VariableSnapshotConcurrencyToken string
      Identifies the release’s current variable snapshots.
    • Version string
      Maximum length 349.
    • VersionControlReference object
  • ItemsPerPage integer
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • LastPageNumber integer
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • NumberOfPages integer
  • TotalResults integer

Example Response

JSON
{
  "Id": "string",
  "ItemType": "string",
  "Items": [
    {
      "Assembled": "2020-01-01T00:00:00.000Z",
      "BuildInformation": [
        {}
      ],
      "ChannelId": "Channels-1",
      "CustomFields": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "Id": "Releases-1",
      "IgnoreChannelRules": true,
      "LastModifiedBy": "string",
      "LastModifiedOn": "2020-01-01T00:00:00.000Z",
      "LibraryVariableSetSnapshotIds": [
        "string"
      ],
      "Links": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "ProjectDeploymentProcessSnapshotId": "string",
      "ProjectId": "Projects-1",
      "ProjectVariableSetSnapshotId": "string",
      "ReleaseNotes": "string",
      "SelectedGitResources": [
        {}
      ],
      "SelectedPackages": [
        {}
      ],
      "SpaceId": "Spaces-1",
      "VariableSnapshotConcurrencyToken": "string",
      "Version": "string",
      "VersionControlReference": {
        "GitCommit": "string",
        "GitRef": "string",
        "VariablesGitCommit": "string"
      }
    }
  ],
  "ItemsPerPage": 0,
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "LastPageNumber": 0,
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "NumberOfPages": 0,
  "TotalResults": 0
}

List all of the releases that belong to the given Channel

GET /api/{spaceId}/projects/{projectId}/channels/{id}/releases

Also reachable at /api/projects/{projectId}/channels/{id}/releases, /api/spaces/{spaceIdentifier}/projects/{projectId}/channels/{id}/releases.

Releases will be ordered from most recent to least recent,

Path Parameters

  • id string (required)
    ID of the Channel to get Releases for.
  • projectId string (required)
    ID of the Project to which the given Channel belongs.
  • spaceId string (required)
    ID of the Space to which the given Channel belongs.

Query Parameters

  • searchByVersion string
    A partial version, to limit the set of Releases to those with a version that includes the partial version.
  • skip integer
    Number of items to skip. Defaults to zero. Minimum 0.
  • take integer
    Number of items to take. Defaults to 30. Minimum 0.

Response

200 — List of Releases on the given Channel.

  • Id string
    Gets or sets a unique identifier for this resource.
  • ItemType string
  • Items array of object
    • Assembled string
      Format date-time.
    • BuildInformation array of object
    • ChannelId string
    • CustomFields object
    • Id string
      Gets or sets a unique identifier for this resource.
    • IgnoreChannelRules boolean
    • LastModifiedBy string
      Gets or sets the username of the user who last modified this resource.
    • LastModifiedOn string
      Gets or sets the date/time that this resource was last modified. Format date-time.
    • LibraryVariableSetSnapshotIds array of string
      Snapshots of the project’s included library variable sets. The snapshots are VariableSetResources, not LibraryVariableSetResources.
    • Links object
      Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
    • ProjectDeploymentProcessSnapshotId string
    • ProjectId string
    • ProjectVariableSetSnapshotId string
    • ReleaseNotes string
    • SelectedGitResources array of object
    • SelectedPackages array of object
    • SpaceId string
    • VariableSnapshotConcurrencyToken string
      Identifies the release’s current variable snapshots.
    • Version string
      Maximum length 349.
    • VersionControlReference object
  • ItemsPerPage integer
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • LastPageNumber integer
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • NumberOfPages integer
  • TotalResults integer

Example Response

JSON
{
  "Id": "string",
  "ItemType": "string",
  "Items": [
    {
      "Assembled": "2020-01-01T00:00:00.000Z",
      "BuildInformation": [
        {}
      ],
      "ChannelId": "Channels-1",
      "CustomFields": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "Id": "Releases-1",
      "IgnoreChannelRules": true,
      "LastModifiedBy": "string",
      "LastModifiedOn": "2020-01-01T00:00:00.000Z",
      "LibraryVariableSetSnapshotIds": [
        "string"
      ],
      "Links": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "ProjectDeploymentProcessSnapshotId": "string",
      "ProjectId": "Projects-1",
      "ProjectVariableSetSnapshotId": "string",
      "ReleaseNotes": "string",
      "SelectedGitResources": [
        {}
      ],
      "SelectedPackages": [
        {}
      ],
      "SpaceId": "Spaces-1",
      "VariableSnapshotConcurrencyToken": "string",
      "Version": "string",
      "VersionControlReference": {
        "GitCommit": "string",
        "GitRef": "string",
        "VariablesGitCommit": "string"
      }
    }
  ],
  "ItemsPerPage": 0,
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "LastPageNumber": 0,
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "NumberOfPages": 0,
  "TotalResults": 0
}

List all of the releases that belong to the given Project

GET /api/{spaceId}/projects/{projectId}/releases

Also reachable at /api/projects/{projectId}/releases, /api/spaces/{spaceIdentifier}/projects/{projectId}/releases.

Releases will be ordered from most recent to least recent

Path Parameters

  • projectId string (required)
    ID of the Project to get Releases for.
  • spaceId string (required)
    ID of the Space to which the given Project belongs.

Query Parameters

  • searchByVersion string
    A partial version, to limit the set of Releases to those with a version that includes the partial version.
  • skip integer
    Number of items to skip. Defaults to zero. Minimum 0.
  • take integer
    Number of items to take. Defaults to 30. Minimum 0.

Response

200 — The list of Releases

  • Id string
    Gets or sets a unique identifier for this resource.
  • ItemType string
  • Items array of object
    • Assembled string
      Format date-time.
    • BuildInformation array of object
    • ChannelId string
    • CustomFields object
    • Id string
      Gets or sets a unique identifier for this resource.
    • IgnoreChannelRules boolean
    • LastModifiedBy string
      Gets or sets the username of the user who last modified this resource.
    • LastModifiedOn string
      Gets or sets the date/time that this resource was last modified. Format date-time.
    • LibraryVariableSetSnapshotIds array of string
      Snapshots of the project’s included library variable sets. The snapshots are VariableSetResources, not LibraryVariableSetResources.
    • Links object
      Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
    • ProjectDeploymentProcessSnapshotId string
    • ProjectId string
    • ProjectVariableSetSnapshotId string
    • ReleaseNotes string
    • SelectedGitResources array of object
    • SelectedPackages array of object
    • SpaceId string
    • VariableSnapshotConcurrencyToken string
      Identifies the release’s current variable snapshots.
    • Version string
      Maximum length 349.
    • VersionControlReference object
  • ItemsPerPage integer
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • LastPageNumber integer
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • NumberOfPages integer
  • TotalResults integer

Example Response

JSON
{
  "Id": "string",
  "ItemType": "string",
  "Items": [
    {
      "Assembled": "2020-01-01T00:00:00.000Z",
      "BuildInformation": [
        {}
      ],
      "ChannelId": "Channels-1",
      "CustomFields": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "Id": "Releases-1",
      "IgnoreChannelRules": true,
      "LastModifiedBy": "string",
      "LastModifiedOn": "2020-01-01T00:00:00.000Z",
      "LibraryVariableSetSnapshotIds": [
        "string"
      ],
      "Links": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "ProjectDeploymentProcessSnapshotId": "string",
      "ProjectId": "Projects-1",
      "ProjectVariableSetSnapshotId": "string",
      "ReleaseNotes": "string",
      "SelectedGitResources": [
        {}
      ],
      "SelectedPackages": [
        {}
      ],
      "SpaceId": "Spaces-1",
      "VariableSnapshotConcurrencyToken": "string",
      "Version": "string",
      "VersionControlReference": {
        "GitCommit": "string",
        "GitRef": "string",
        "VariablesGitCommit": "string"
      }
    }
  ],
  "ItemsPerPage": 0,
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "LastPageNumber": 0,
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "NumberOfPages": 0,
  "TotalResults": 0
}

Get a list of Variable Sets included in the Release’s current Variable Snapshot

GET /api/{spaceId}/projects/{projectId}/releases/{id}/variables

Also reachable at /api/projects/{projectId}/releases/{id}/variables, /api/spaces/{spaceIdentifier}/projects/{projectId}/releases/{id}/variables.

Path Parameters

  • id string (required)
    ID of the Release to get variables for.
  • projectId string (required)
    ID of the Project the Release is in.
  • spaceId string (required)
    The ID of the space containing the resource(s).

Response

200 — The requested list of Variables

  • Id string
    Gets or sets a unique identifier for this resource.
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • OwnerId string
    Gets or sets the ID of the document that owns these variables.
  • ScopeValues object
    • Actions array of object
    • Channels array of object
    • EnvironmentParameters array of object
    • Environments array of object
    • Machines array of object
    • ProcessTemplateSteps array of object
    • Processes array of object
    • Roles array of object
    • TargetTagParameters array of object
    • TenantTagParameters array of object
    • TenantTags array of object
  • SpaceId string
  • Variables array of object
    Gets the collection of variables.
    • Description string
    • Id string
    • IsEditable boolean
    • IsSensitive boolean
    • Name string
    • Prompt object
    • Scope object
    • Type string
    • Value string
  • Version integer
    Gets or sets the version number.

Example Response

JSON
[
  {
    "Id": "string",
    "LastModifiedBy": "string",
    "LastModifiedOn": "2020-01-01T00:00:00.000Z",
    "Links": {
      "additionalProp1": "string",
      "additionalProp2": "string",
      "additionalProp3": "string"
    },
    "OwnerId": "string",
    "ScopeValues": {
      "Actions": [
        {}
      ],
      "Channels": [
        {}
      ],
      "EnvironmentParameters": [
        {}
      ],
      "Environments": [
        {}
      ],
      "Machines": [
        {}
      ],
      "ProcessTemplateSteps": [
        {}
      ],
      "Processes": [
        {}
      ],
      "Roles": [
        {}
      ],
      "TargetTagParameters": [
        {}
      ],
      "TenantTagParameters": [
        {}
      ],
      "TenantTags": [
        {}
      ]
    },
    "SpaceId": "Spaces-1",
    "Variables": [
      {
        "Description": "string",
        "Id": "string",
        "IsEditable": true,
        "IsSensitive": true,
        "Name": "string",
        "Prompt": {},
        "Scope": {},
        "Type": "string",
        "Value": "string"
      }
    ],
    "Version": 0
  }
]

Get a single release by project ID and version number

GET /api/{spaceId}/projects/{projectId}/releases/{version}

Also reachable at /api/projects/{projectId}/releases/{version}, /api/spaces/{spaceIdentifier}/projects/{projectId}/releases/{version}.

Path Parameters

  • projectId string (required)
    The ID of the project containing the release.
  • spaceId string (required)
    The ID of the space containing the release.
  • version string (required)
    The version of the requested release.

Response

200 — Success

  • Assembled string
    Format date-time.
  • BuildInformation array of object
    • Branch string
    • BuildEnvironment string
    • BuildNumber string
    • BuildUrl string
    • Commits array of object
    • IssueTrackerName string
    • PackageId string
    • VcsCommitNumber string
    • VcsCommitUrl string
    • VcsRoot string
    • VcsType string
    • Version string
    • WorkItems array of object
  • ChannelId string
  • CustomFields object
  • Id string
    Gets or sets a unique identifier for this resource.
  • IgnoreChannelRules boolean
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • LibraryVariableSetSnapshotIds array of string
    Snapshots of the project’s included library variable sets. The snapshots are VariableSetResources, not LibraryVariableSetResources.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • ProjectDeploymentProcessSnapshotId string
  • ProjectId string
  • ProjectVariableSetSnapshotId string
  • ReleaseNotes string
  • SelectedGitResources array of object
    • ActionName string
      Minimum length 1.
    • GitReferenceResource object
    • GitResourceReferenceName string
  • SelectedPackages array of object
    • ActionName string
    • PackageReferenceName string
    • StepName string
    • Version string
  • SpaceId string
  • VariableSnapshotConcurrencyToken string
    Identifies the release’s current variable snapshots.
  • Version string
    Maximum length 349.
  • VersionControlReference object
    • GitCommit string
    • GitRef string
    • VariablesGitCommit string

Example Response

JSON
{
  "Assembled": "2020-01-01T00:00:00.000Z",
  "BuildInformation": [
    {
      "Branch": "string",
      "BuildEnvironment": "string",
      "BuildNumber": "string",
      "BuildUrl": "string",
      "Commits": [
        {}
      ],
      "IssueTrackerName": "string",
      "PackageId": "string",
      "VcsCommitNumber": "string",
      "VcsCommitUrl": "string",
      "VcsRoot": "string",
      "VcsType": "string",
      "Version": "string",
      "WorkItems": [
        {}
      ]
    }
  ],
  "ChannelId": "Channels-1",
  "CustomFields": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "Id": "Releases-1",
  "IgnoreChannelRules": true,
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "LibraryVariableSetSnapshotIds": [
    "string"
  ],
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "ProjectDeploymentProcessSnapshotId": "string",
  "ProjectId": "Projects-1",
  "ProjectVariableSetSnapshotId": "string",
  "ReleaseNotes": "string",
  "SelectedGitResources": [
    {
      "ActionName": "string",
      "GitReferenceResource": {
        "GitCommit": "string",
        "GitRef": "string"
      },
      "GitResourceReferenceName": "string"
    }
  ],
  "SelectedPackages": [
    {
      "ActionName": "string",
      "PackageReferenceName": "string",
      "StepName": "string",
      "Version": "string"
    }
  ],
  "SpaceId": "Spaces-1",
  "VariableSnapshotConcurrencyToken": "string",
  "Version": "string",
  "VersionControlReference": {
    "GitCommit": "string",
    "GitRef": "string",
    "VariablesGitCommit": "string"
  }
}

Get a list of Releases for the given Space

GET /api/{spaceId}/releases

Also reachable at /api/releases, /api/spaces/{spaceIdentifier}/releases.

Lists all of the Releases in the supplied Octopus Deploy Space, from all projects. The results will be sorted from most recent to least recent release.

Path Parameters

  • spaceId string (required)
    ID of the Space to which the Releases belong.

Query Parameters

  • skip integer
    Number of items to skip. Defaults to zero. Minimum 0.
  • take integer
    Number of items to take. Defaults to 30. Minimum 0.

Response

200 — The list of Releases for the requested Space.

  • Id string
    Gets or sets a unique identifier for this resource.
  • ItemType string
  • Items array of object
    • Assembled string
      Format date-time.
    • BuildInformation array of object
    • ChannelId string
    • CustomFields object
    • Id string
      Gets or sets a unique identifier for this resource.
    • IgnoreChannelRules boolean
    • LastModifiedBy string
      Gets or sets the username of the user who last modified this resource.
    • LastModifiedOn string
      Gets or sets the date/time that this resource was last modified. Format date-time.
    • LibraryVariableSetSnapshotIds array of string
      Snapshots of the project’s included library variable sets. The snapshots are VariableSetResources, not LibraryVariableSetResources.
    • Links object
      Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
    • ProjectDeploymentProcessSnapshotId string
    • ProjectId string
    • ProjectVariableSetSnapshotId string
    • ReleaseNotes string
    • SelectedGitResources array of object
    • SelectedPackages array of object
    • SpaceId string
    • VariableSnapshotConcurrencyToken string
      Identifies the release’s current variable snapshots.
    • Version string
      Maximum length 349.
    • VersionControlReference object
  • ItemsPerPage integer
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • LastPageNumber integer
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • NumberOfPages integer
  • TotalResults integer

Example Response

JSON
{
  "Id": "string",
  "ItemType": "string",
  "Items": [
    {
      "Assembled": "2020-01-01T00:00:00.000Z",
      "BuildInformation": [
        {}
      ],
      "ChannelId": "Channels-1",
      "CustomFields": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "Id": "Releases-1",
      "IgnoreChannelRules": true,
      "LastModifiedBy": "string",
      "LastModifiedOn": "2020-01-01T00:00:00.000Z",
      "LibraryVariableSetSnapshotIds": [
        "string"
      ],
      "Links": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "ProjectDeploymentProcessSnapshotId": "string",
      "ProjectId": "Projects-1",
      "ProjectVariableSetSnapshotId": "string",
      "ReleaseNotes": "string",
      "SelectedGitResources": [
        {}
      ],
      "SelectedPackages": [
        {}
      ],
      "SpaceId": "Spaces-1",
      "VariableSnapshotConcurrencyToken": "string",
      "Version": "string",
      "VersionControlReference": {
        "GitCommit": "string",
        "GitRef": "string",
        "VariablesGitCommit": "string"
      }
    }
  ],
  "ItemsPerPage": 0,
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "LastPageNumber": 0,
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "NumberOfPages": 0,
  "TotalResults": 0
}

Create a Release

POST /api/{spaceId}/releases

Also reachable at /api/releases, /api/spaces/{spaceIdentifier}/releases.

Path Parameters

  • spaceId string (required)

Request Body

  • Assembled string
    Format date-time.
  • ChannelId string
  • CustomFields object
  • IgnoreChannelRules boolean
    Ignore channel rules.
  • ProjectId string (required)
  • ReleaseNotes string
  • SelectedGitResources array of object
    • ActionName string (required)
      Minimum length 1.
    • GitReferenceResource object (required)
    • GitResourceReferenceName string
  • SelectedPackages array of object
    • ActionName string
    • PackageReferenceName string
    • StepName string
    • Version string
  • SpaceId string (required)
  • Version string (required)
    Maximum length 349.
  • VersionControlReference object
    • GitCommit string
    • GitRef string
    • VariablesGitCommit string

Response

201 — Created

  • Assembled string
    Format date-time.
  • BuildInformation array of object
    • Branch string
    • BuildEnvironment string
    • BuildNumber string
    • BuildUrl string
    • Commits array of object
    • IssueTrackerName string
    • PackageId string
    • VcsCommitNumber string
    • VcsCommitUrl string
    • VcsRoot string
    • VcsType string
    • Version string
    • WorkItems array of object
  • ChannelId string
  • CustomFields object
  • Id string
    Gets or sets a unique identifier for this resource.
  • IgnoreChannelRules boolean
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • LibraryVariableSetSnapshotIds array of string
    Snapshots of the project’s included library variable sets. The snapshots are VariableSetResources, not LibraryVariableSetResources.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • ProjectDeploymentProcessSnapshotId string
  • ProjectId string
  • ProjectVariableSetSnapshotId string
  • ReleaseNotes string
  • SelectedGitResources array of object
    • ActionName string
      Minimum length 1.
    • GitReferenceResource object
    • GitResourceReferenceName string
  • SelectedPackages array of object
    • ActionName string
    • PackageReferenceName string
    • StepName string
    • Version string
  • SpaceId string
  • VariableSnapshotConcurrencyToken string
    Identifies the release’s current variable snapshots.
  • Version string
    Maximum length 349.
  • VersionControlReference object
    • GitCommit string
    • GitRef string
    • VariablesGitCommit string

Example Request

JSON
{
  "Assembled": "2020-01-01T00:00:00.000Z",
  "ChannelId": "Channels-1",
  "CustomFields": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "IgnoreChannelRules": true,
  "ProjectId": "Projects-1",
  "ReleaseNotes": "string",
  "SelectedGitResources": [
    {
      "ActionName": "string",
      "GitReferenceResource": {
        "GitCommit": "string",
        "GitRef": "string"
      },
      "GitResourceReferenceName": "string"
    }
  ],
  "SelectedPackages": [
    {
      "ActionName": "string",
      "PackageReferenceName": "string",
      "StepName": "string",
      "Version": "string"
    }
  ],
  "SpaceId": "Spaces-1",
  "Version": "string",
  "VersionControlReference": {
    "GitCommit": "string",
    "GitRef": "string",
    "VariablesGitCommit": "string"
  }
}

Example Response

JSON
{
  "Assembled": "2020-01-01T00:00:00.000Z",
  "BuildInformation": [
    {
      "Branch": "string",
      "BuildEnvironment": "string",
      "BuildNumber": "string",
      "BuildUrl": "string",
      "Commits": [
        {}
      ],
      "IssueTrackerName": "string",
      "PackageId": "string",
      "VcsCommitNumber": "string",
      "VcsCommitUrl": "string",
      "VcsRoot": "string",
      "VcsType": "string",
      "Version": "string",
      "WorkItems": [
        {}
      ]
    }
  ],
  "ChannelId": "Channels-1",
  "CustomFields": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "Id": "Releases-1",
  "IgnoreChannelRules": true,
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "LibraryVariableSetSnapshotIds": [
    "string"
  ],
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "ProjectDeploymentProcessSnapshotId": "string",
  "ProjectId": "Projects-1",
  "ProjectVariableSetSnapshotId": "string",
  "ReleaseNotes": "string",
  "SelectedGitResources": [
    {
      "ActionName": "string",
      "GitReferenceResource": {
        "GitCommit": "string",
        "GitRef": "string"
      },
      "GitResourceReferenceName": "string"
    }
  ],
  "SelectedPackages": [
    {
      "ActionName": "string",
      "PackageReferenceName": "string",
      "StepName": "string",
      "Version": "string"
    }
  ],
  "SpaceId": "Spaces-1",
  "VariableSnapshotConcurrencyToken": "string",
  "Version": "string",
  "VersionControlReference": {
    "GitCommit": "string",
    "GitRef": "string",
    "VariablesGitCommit": "string"
  }
}

Create a Release

POST /api/{spaceId}/releases/create/v1

Also reachable at /api/releases/create/v1, /api/spaces/{spaceIdentifier}/releases/create/v1.

Path Parameters

  • spaceId string (required)

Request Body

  • ChannelName string
    Name of the channel to use for the new release. Omit this argument to automatically select the best channel.
  • CustomFields object
    Values for the project’s custom release fields, if it defines any, keyed by field name.
  • GitCommit string
    Only set alongside GitRef, when a specific commit is needed; GitRef alone uses the tip of that ref.
  • GitRef string
    The Git branch, tag or commit to snapshot the deployment process from. Required for a project that stores its configuration in Git, and must be left unset for one stored in the database — the command fails either way round. List a project’s branches with get_branches.
  • GitResources array of string
    Git ref to use for a git resource in the release. Format: StepName or StepName:GitResourceName. If the GitResourceName is omitted, it’s assumed to be the primary git resource for the step. The GitRef can be replaced with an asterisk. An asterisk will use the tip ref of the step-defined default branch.
  • IgnoreChannelRules boolean
    Create the release even when a package version, or the Git reference, violates the channel’s version rules. This overrides a deliberate guardrail, so prefer correcting the versions or letting Octopus select the channel; only set it when explicitly asked to.
  • IgnoreIfAlreadyExists boolean
    If a release with the same version number already exists, return that one instead of failing — so the returned ReleaseId may be an existing release rather than a newly created one.
  • PackagePrerelease string
    Restrict automatic version selection to pre-release versions carrying this tag, for example “beta”. Ignored for steps whose version is pinned by PackageVersion or Packages.
  • PackageVersion string
    One version to use for every package step. Leave unset to take the latest version of each package; use Packages instead to pin versions per step.
  • Packages array of string
    Version number to use for a package in the release. Format: StepName or PackageID or StepName:PackageName. StepName, PackageID, and PackageName can be replaced with an asterisk. An asterisk will be assumed for StepName, PackageID, or PackageName if they are omitted.
  • ProjectName string (required)
  • ReleaseNotes string
    Release Notes for the new release. Styling with Markdown is supported.
  • ReleaseVersion string
    Leave unset to let Octopus pick the next version from the project’s versioning strategy, which is usually what you want.
  • SpaceId string (required)
  • SpaceIdOrName string (required)
    Both this and SpaceId are required, and normally hold the same space ID; set both.

Response

201 — Created

  • ReleaseId string
  • ReleaseVersion string
    Minimum length 1.

Example Request

JSON
{
  "ChannelName": "string",
  "CustomFields": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "GitCommit": "string",
  "GitRef": "string",
  "GitResources": [
    "string"
  ],
  "IgnoreChannelRules": true,
  "IgnoreIfAlreadyExists": true,
  "PackagePrerelease": "string",
  "PackageVersion": "string",
  "Packages": [
    "string"
  ],
  "ProjectName": "string",
  "ReleaseNotes": "string",
  "ReleaseVersion": "string",
  "SpaceId": "Spaces-1",
  "SpaceIdOrName": "string"
}

Example Response

JSON
{
  "ReleaseId": "Releases-1",
  "ReleaseVersion": "string"
}

Get a Release by ID

GET /api/{spaceId}/releases/{id}

Also reachable at /api/releases/{id}, /api/spaces/{spaceIdentifier}/releases/{id}.

Path Parameters

  • id string (required)
    ID of the Release to load.
  • spaceId string (required)
    ID of the Space that owns the Release.

Response

200 — The requested Release

  • Assembled string
    Format date-time.
  • BuildInformation array of object
    • Branch string
    • BuildEnvironment string
    • BuildNumber string
    • BuildUrl string
    • Commits array of object
    • IssueTrackerName string
    • PackageId string
    • VcsCommitNumber string
    • VcsCommitUrl string
    • VcsRoot string
    • VcsType string
    • Version string
    • WorkItems array of object
  • ChannelId string
  • CustomFields object
  • Id string
    Gets or sets a unique identifier for this resource.
  • IgnoreChannelRules boolean
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • LibraryVariableSetSnapshotIds array of string
    Snapshots of the project’s included library variable sets. The snapshots are VariableSetResources, not LibraryVariableSetResources.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • ProjectDeploymentProcessSnapshotId string
  • ProjectId string
  • ProjectVariableSetSnapshotId string
  • ReleaseNotes string
  • SelectedGitResources array of object
    • ActionName string
      Minimum length 1.
    • GitReferenceResource object
    • GitResourceReferenceName string
  • SelectedPackages array of object
    • ActionName string
    • PackageReferenceName string
    • StepName string
    • Version string
  • SpaceId string
  • VariableSnapshotConcurrencyToken string
    Identifies the release’s current variable snapshots.
  • Version string
    Maximum length 349.
  • VersionControlReference object
    • GitCommit string
    • GitRef string
    • VariablesGitCommit string

Example Response

JSON
{
  "Assembled": "2020-01-01T00:00:00.000Z",
  "BuildInformation": [
    {
      "Branch": "string",
      "BuildEnvironment": "string",
      "BuildNumber": "string",
      "BuildUrl": "string",
      "Commits": [
        {}
      ],
      "IssueTrackerName": "string",
      "PackageId": "string",
      "VcsCommitNumber": "string",
      "VcsCommitUrl": "string",
      "VcsRoot": "string",
      "VcsType": "string",
      "Version": "string",
      "WorkItems": [
        {}
      ]
    }
  ],
  "ChannelId": "Channels-1",
  "CustomFields": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "Id": "Releases-1",
  "IgnoreChannelRules": true,
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "LibraryVariableSetSnapshotIds": [
    "string"
  ],
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "ProjectDeploymentProcessSnapshotId": "string",
  "ProjectId": "Projects-1",
  "ProjectVariableSetSnapshotId": "string",
  "ReleaseNotes": "string",
  "SelectedGitResources": [
    {
      "ActionName": "string",
      "GitReferenceResource": {
        "GitCommit": "string",
        "GitRef": "string"
      },
      "GitResourceReferenceName": "string"
    }
  ],
  "SelectedPackages": [
    {
      "ActionName": "string",
      "PackageReferenceName": "string",
      "StepName": "string",
      "Version": "string"
    }
  ],
  "SpaceId": "Spaces-1",
  "VariableSnapshotConcurrencyToken": "string",
  "Version": "string",
  "VersionControlReference": {
    "GitCommit": "string",
    "GitRef": "string",
    "VariablesGitCommit": "string"
  }
}

Update an existing Release

PUT /api/{spaceId}/releases/{id}

Also reachable at /api/releases/{id}, /api/spaces/{spaceIdentifier}/releases/{id}.

Path Parameters

  • id string (required)
    ID of the Release.
  • spaceId string (required)

Request Body

  • ChannelId string (required)
  • CustomFields object
  • Id string (required)
    ID of the Release.
  • IgnoreChannelRules boolean
    If altering the Channel of an existing Release, its rules may be violated. This ignores those violations. If not altering the Release Channel, this parameter is ignored.
  • ProjectId string (required)
  • ReleaseNotes string
  • SelectedGitResources array of object
    • ActionName string (required)
      Minimum length 1.
    • GitReferenceResource object (required)
    • GitResourceReferenceName string
  • SelectedPackages array of object
    • ActionName string
    • PackageReferenceName string
    • StepName string
    • Version string
  • SpaceId string (required)
  • Version string (required)
    Maximum length 349.

Response

200 — Confirmation that the Release was modified, containing the updated Release

  • Assembled string
    Format date-time.
  • BuildInformation array of object
    • Branch string
    • BuildEnvironment string
    • BuildNumber string
    • BuildUrl string
    • Commits array of object
    • IssueTrackerName string
    • PackageId string
    • VcsCommitNumber string
    • VcsCommitUrl string
    • VcsRoot string
    • VcsType string
    • Version string
    • WorkItems array of object
  • ChannelId string
  • CustomFields object
  • Id string
    Gets or sets a unique identifier for this resource.
  • IgnoreChannelRules boolean
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • LibraryVariableSetSnapshotIds array of string
    Snapshots of the project’s included library variable sets. The snapshots are VariableSetResources, not LibraryVariableSetResources.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • ProjectDeploymentProcessSnapshotId string
  • ProjectId string
  • ProjectVariableSetSnapshotId string
  • ReleaseNotes string
  • SelectedGitResources array of object
    • ActionName string
      Minimum length 1.
    • GitReferenceResource object
    • GitResourceReferenceName string
  • SelectedPackages array of object
    • ActionName string
    • PackageReferenceName string
    • StepName string
    • Version string
  • SpaceId string
  • VariableSnapshotConcurrencyToken string
    Identifies the release’s current variable snapshots.
  • Version string
    Maximum length 349.
  • VersionControlReference object
    • GitCommit string
    • GitRef string
    • VariablesGitCommit string

Example Request

JSON
{
  "ChannelId": "Channels-1",
  "CustomFields": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "Id": "Releases-1",
  "IgnoreChannelRules": true,
  "ProjectId": "Projects-1",
  "ReleaseNotes": "string",
  "SelectedGitResources": [
    {
      "ActionName": "string",
      "GitReferenceResource": {
        "GitCommit": "string",
        "GitRef": "string"
      },
      "GitResourceReferenceName": "string"
    }
  ],
  "SelectedPackages": [
    {
      "ActionName": "string",
      "PackageReferenceName": "string",
      "StepName": "string",
      "Version": "string"
    }
  ],
  "SpaceId": "Spaces-1",
  "Version": "string"
}

Example Response

JSON
{
  "Assembled": "2020-01-01T00:00:00.000Z",
  "BuildInformation": [
    {
      "Branch": "string",
      "BuildEnvironment": "string",
      "BuildNumber": "string",
      "BuildUrl": "string",
      "Commits": [
        {}
      ],
      "IssueTrackerName": "string",
      "PackageId": "string",
      "VcsCommitNumber": "string",
      "VcsCommitUrl": "string",
      "VcsRoot": "string",
      "VcsType": "string",
      "Version": "string",
      "WorkItems": [
        {}
      ]
    }
  ],
  "ChannelId": "Channels-1",
  "CustomFields": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "Id": "Releases-1",
  "IgnoreChannelRules": true,
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "LibraryVariableSetSnapshotIds": [
    "string"
  ],
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "ProjectDeploymentProcessSnapshotId": "string",
  "ProjectId": "Projects-1",
  "ProjectVariableSetSnapshotId": "string",
  "ReleaseNotes": "string",
  "SelectedGitResources": [
    {
      "ActionName": "string",
      "GitReferenceResource": {
        "GitCommit": "string",
        "GitRef": "string"
      },
      "GitResourceReferenceName": "string"
    }
  ],
  "SelectedPackages": [
    {
      "ActionName": "string",
      "PackageReferenceName": "string",
      "StepName": "string",
      "Version": "string"
    }
  ],
  "SpaceId": "Spaces-1",
  "VariableSnapshotConcurrencyToken": "string",
  "Version": "string",
  "VersionControlReference": {
    "GitCommit": "string",
    "GitRef": "string",
    "VariablesGitCommit": "string"
  }
}

Delete an existing release, along with all of the deployments, tasks and other associated resources belonging to the release

DELETE /api/{spaceId}/releases/{id}

Also reachable at /api/releases/{id}, /api/spaces/{spaceIdentifier}/releases/{id}.

Path Parameters

  • id string (required)
    Id of the Release to delete.
  • spaceId string (required)
    The ID of the space containing the resource(s).

Response

200 — Success

Get all of the information necessary for creating or editing a deployment for this release

GET /api/{spaceId}/releases/{id}/deployments/template

Also reachable at /api/releases/{id}/deployments/template, /api/spaces/{spaceIdentifier}/releases/{id}/deployments/template.

Path Parameters

  • id string (required)
    ID of the Release.
  • spaceId string (required)
    ID of the Space.

Response

200 — The requested Deployment Template for the release.

  • DeploymentNotes string
  • Id string
    Gets or sets a unique identifier for this resource.
  • IsDeploymentProcessModified boolean
  • IsGitResourceModified boolean
  • IsLibraryVariableSetModified boolean
  • IsVariableSetModified boolean
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • PromoteTo array of object
    • Id string
    • Links object
    • Name string
  • TenantPromotions array of object
    • Id string
      Gets or sets a unique identifier for this resource.
    • LastModifiedBy string
      Gets or sets the username of the user who last modified this resource.
    • LastModifiedOn string
      Gets or sets the date/time that this resource was last modified. Format date-time.
    • Links object
      Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
    • Name string
    • PromoteTo array of object

Example Response

JSON
{
  "DeploymentNotes": "string",
  "Id": "string",
  "IsDeploymentProcessModified": true,
  "IsGitResourceModified": true,
  "IsLibraryVariableSetModified": true,
  "IsVariableSetModified": true,
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "PromoteTo": [
    {
      "Id": "Environments-1",
      "Links": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "Name": "string"
    }
  ],
  "TenantPromotions": [
    {
      "Id": "string",
      "LastModifiedBy": "string",
      "LastModifiedOn": "2020-01-01T00:00:00.000Z",
      "Links": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "Name": "string",
      "PromoteTo": [
        {}
      ]
    }
  ]
}

Get all defects for a release

GET /api/{spaceId}/releases/{releaseId}/defects

Also reachable at /api/releases/{releaseId}/defects, /api/spaces/{spaceIdentifier}/releases/{releaseId}/defects.

Path Parameters

  • releaseId string (required)
    Id of the release.
  • spaceId string (required)
    The ID of the space containing the resource(s).

Response

200 — Get all defects for a release.

  • Id string
    Gets or sets a unique identifier for this resource.
  • ItemType string
  • Items array of object
    • Description string
      Minimum length 1.
    • Id string
      Gets or sets a unique identifier for this resource.
    • LastModifiedBy string
      Gets or sets the username of the user who last modified this resource.
    • LastModifiedOn string
      Gets or sets the date/time that this resource was last modified. Format date-time.
    • Links object
      Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
    • Status enum
      Allowed values: Unresolved, Resolved.
  • ItemsPerPage integer
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • LastPageNumber integer
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • NumberOfPages integer
  • TotalResults integer

Example Response

JSON
{
  "Id": "string",
  "ItemType": "string",
  "Items": [
    {
      "Description": "string",
      "Id": "string",
      "LastModifiedBy": "string",
      "LastModifiedOn": "2020-01-01T00:00:00.000Z",
      "Links": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "Status": "Unresolved"
    }
  ],
  "ItemsPerPage": 0,
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "LastPageNumber": 0,
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "NumberOfPages": 0,
  "TotalResults": 0
}

Record defect in a release

POST /api/{spaceId}/releases/{releaseId}/defects

Also reachable at /api/releases/{releaseId}/defects, /api/spaces/{spaceIdentifier}/releases/{releaseId}/defects.

Path Parameters

  • releaseId string (required)
    Id of the release.
  • spaceId string (required)
    The ID of the space containing the resource(s).

Request Body

  • Description string (required)
    Defect in the release. Minimum length 1.
  • ReleaseId string (required)
    Id of the release.
  • SpaceId string (required)
    The ID of the space containing the resource(s).
  • Status string

Response

200 — The defect resource that was recorded against a release

  • Description string
    Minimum length 1.
  • Id string
    Gets or sets a unique identifier for this resource.
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • Status enum
    Allowed values: Unresolved, Resolved.

Example Request

JSON
{
  "Description": "string",
  "ReleaseId": "Releases-1",
  "SpaceId": "Spaces-1",
  "Status": "string"
}

Example Response

JSON
{
  "Description": "string",
  "Id": "string",
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "Status": "Unresolved"
}

Resolve defect in a release

POST /api/{spaceId}/releases/{releaseId}/defects/resolve

Also reachable at /api/releases/{releaseId}/defects/resolve, /api/spaces/{spaceIdentifier}/releases/{releaseId}/defects/resolve.

Path Parameters

  • releaseId string (required)
    Id of the release.
  • spaceId string (required)
    The ID of the space containing the release.

Response

200 — Resolved defect

  • Description string
    Minimum length 1.
  • Id string
    Gets or sets a unique identifier for this resource.
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • Status enum
    Allowed values: Unresolved, Resolved.

Example Response

JSON
{
  "Description": "string",
  "Id": "string",
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "Status": "Unresolved"
}

List all of the Deployments that belong to the given Release

GET /api/{spaceId}/releases/{releaseId}/deployments

Also reachable at /api/releases/{releaseId}/deployments, /api/spaces/{spaceIdentifier}/releases/{releaseId}/deployments.

Deployments will be ordered from most recent to least recent.

Path Parameters

  • releaseId string (required)
    ID of the Release to load.
  • spaceId string (required)
    ID of the Space to which the Release belongs.

Query Parameters

  • skip integer
    Number of items to skip. Defaults to zero. Minimum 0.
  • take integer
    Number of items to take. Defaults to 30. Minimum 0.

Response

200 — The list of Deployments for the given Release.

  • Id string
    Gets or sets a unique identifier for this resource.
  • ItemType string
  • Items array of object
    • ChangeRequestSettings array of object
    • Changes array of object
    • ChangesMarkdown string
    • ChannelId string
    • Comments string
    • Created string
      Format date-time.
    • DebugMode string
    • DeployedBy string
    • DeployedById string
    • DeployedToMachineIds array of string
    • DeploymentProcessId string
    • EnvironmentId string
    • ExcludedMachineIds array of string
      A collection of machines in the target environment that should be excluded from the deployment.
    • ExcludedTargetTagIds array of string
      A collection of target tag IDs that should be excluded from the deployment. Only deployment targets that have none of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.
    • ExecutionPlanLogContext object
    • FailTargetDiscovery boolean
    • FailureEncountered boolean
    • ForcePackageDownload boolean
    • ForcePackageRedeployment boolean
    • FormValues object
    • Id string
      Gets or sets a unique identifier for this resource.
    • LastModifiedBy string
      Gets or sets the username of the user who last modified this resource.
    • LastModifiedOn string
      Gets or sets the date/time that this resource was last modified. Format date-time.
    • Links object
      Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
    • ManifestVariableSetId string
    • Name string
    • Priority string
    • ProjectId string
    • QueueTime string
      If set this time will be the used to schedule the deployment to a later time, null is assumed to mean the time will be executed immediately. Format date-time.
    • QueueTimeExpiry string
      Format date-time.
    • ReleaseId string
    • SkipActions array of string
    • SpaceId string
    • SpecificMachineIds array of string
      A collection of machines in the target environment that should be deployed to. If the collection is empty, all enabled machines are deployed.
    • SpecificTargetTagIds array of string
      A collection of target tag IDs that should be included in the deployment. Only deployment targets that have at least one of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.
    • TaskId string
    • TenantId string
    • TentacleRetentionPeriod object
    • UseGuidedFailure boolean
      If set to true, the deployment will prompt for manual intervention (Fail/Retry/Ignore) when failures are encountered in activities that support it. May be overridden with the Octopus.UseGuidedFailure special variable.
  • ItemsPerPage integer
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • LastPageNumber integer
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • NumberOfPages integer
  • TotalResults integer

Example Response

JSON
{
  "Id": "string",
  "ItemType": "string",
  "Items": [
    {
      "ChangeRequestSettings": [
        {}
      ],
      "Changes": [
        {}
      ],
      "ChangesMarkdown": "string",
      "ChannelId": "Channels-1",
      "Comments": "string",
      "Created": "2020-01-01T00:00:00.000Z",
      "DebugMode": "string",
      "DeployedBy": "string",
      "DeployedById": "string",
      "DeployedToMachineIds": [
        "string"
      ],
      "DeploymentProcessId": "string",
      "EnvironmentId": "Environments-1",
      "ExcludedMachineIds": [
        "string"
      ],
      "ExcludedTargetTagIds": [
        "string"
      ],
      "ExecutionPlanLogContext": {
        "Steps": [
          {}
        ]
      },
      "FailTargetDiscovery": true,
      "FailureEncountered": true,
      "ForcePackageDownload": true,
      "ForcePackageRedeployment": true,
      "FormValues": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "Id": "Deployments-1",
      "LastModifiedBy": "string",
      "LastModifiedOn": "2020-01-01T00:00:00.000Z",
      "Links": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "ManifestVariableSetId": "string",
      "Name": "string",
      "Priority": "string",
      "ProjectId": "Projects-1",
      "QueueTime": "2020-01-01T00:00:00.000Z",
      "QueueTimeExpiry": "2020-01-01T00:00:00.000Z",
      "ReleaseId": "Releases-1",
      "SkipActions": [
        "string"
      ],
      "SpaceId": "Spaces-1",
      "SpecificMachineIds": [
        "string"
      ],
      "SpecificTargetTagIds": [
        "string"
      ],
      "TaskId": "ServerTasks-1",
      "TenantId": "Tenants-1",
      "TentacleRetentionPeriod": {
        "QuantityToKeep": 0,
        "ShouldKeepForever": true,
        "Strategy": "string",
        "Unit": "Days"
      },
      "UseGuidedFailure": true
    }
  ],
  "ItemsPerPage": 0,
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "LastPageNumber": 0,
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "NumberOfPages": 0,
  "TotalResults": 0
}

Get a document that describes what steps will/won’t be run during a deployment to a given environment (and tenant if supplied)

GET /api/{spaceId}/releases/{releaseId}/deployments/preview/{environmentId}

Also reachable at /api/releases/{releaseId}/deployments/preview/{environmentId}, /api/releases/{releaseId}/deployments/preview/{environmentId}/{tenantId}, /api/spaces/{spaceIdentifier}/releases/{releaseId}/deployments/preview/{environmentId}, /api/spaces/{spaceIdentifier}/releases/{releaseId}/deployments/preview/{environmentId}/{tenantId}, /api/{spaceId}/releases/{releaseId}/deployments/preview/{environmentId}/{tenantId}.

Path Parameters

  • environmentId string (required)
    ID of the environment.
  • releaseId string (required)
    ID of the release.
  • spaceId string (required)
    ID of the space containing the resources.

Query Parameters

  • includeDisabledSteps boolean
    Whether to include Disabled Steps in the preview.
  • tenantId string
    ID of the tenant.

Response

200 — The requested Release Deployment Preview

  • Changes array of object
    • BuildInformation array of object
    • Commits array of object
      Aggregate of distinct commits from all VersionMetadata.
    • ReleaseNotes string
    • Version string
    • WorkItems array of object
      Aggregate of distinct work items from all VersionMetadata.
  • ChangesMarkdown string
  • Form object
    • Elements array of object
      Elements of the form.
    • Values object
      Values supplied for the form elements.
  • Id string
    Gets or sets a unique identifier for this resource.
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • StepsToExecute array of object
    • ActionId string
    • ActionName string
    • ActionNumber string
    • AvailableTagSets array of object
    • CanBeSkipped boolean
    • ExcludedMachines array of object
    • HasNoApplicableMachines boolean
    • IsDisabled boolean
    • MachineNames array of string
    • Machines array of object
    • Roles array of string
    • UnavailableMachines array of object
  • UseGuidedFailureModeByDefault boolean

Example Response

JSON
{
  "Changes": [
    {
      "BuildInformation": [
        {}
      ],
      "Commits": [
        {}
      ],
      "ReleaseNotes": "string",
      "Version": "string",
      "WorkItems": [
        {}
      ]
    }
  ],
  "ChangesMarkdown": "string",
  "Form": {
    "Elements": [
      {
        "Control": {},
        "IsValueRequired": true,
        "Name": "string"
      }
    ],
    "Values": {
      "additionalProp1": "string",
      "additionalProp2": "string",
      "additionalProp3": "string"
    }
  },
  "Id": "string",
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "StepsToExecute": [
    {
      "ActionId": "string",
      "ActionName": "string",
      "ActionNumber": "string",
      "AvailableTagSets": [
        {}
      ],
      "CanBeSkipped": true,
      "ExcludedMachines": [
        {}
      ],
      "HasNoApplicableMachines": true,
      "IsDisabled": true,
      "MachineNames": [
        "string"
      ],
      "Machines": [
        {}
      ],
      "Roles": [
        "string"
      ],
      "UnavailableMachines": [
        {}
      ]
    }
  ],
  "UseGuidedFailureModeByDefault": true
}

Return an array of documents that describes what steps will/won’t be run during deployments to a given set of environments and tenants

POST /api/{spaceId}/releases/{releaseId}/deployments/previews

Also reachable at /api/releases/{releaseId}/deployments/previews, /api/spaces/{spaceIdentifier}/releases/{releaseId}/deployments/previews.

Path Parameters

  • releaseId string (required)
    ID of the release.
  • spaceId string (required)
    ID of the space containing the resources.

Request Body

  • DeploymentPreviews array of object (required)
    The array of requests you would like to make.
    • EnvironmentId string
    • TenantId string
  • IncludeDisabledSteps boolean
    Whether to include Disabled Steps in the preview.
  • ReleaseId string (required)
    ID of the release.
  • SpaceId string (required)
    ID of the space containing the resources.

Response

200 — The requested array of Release Deployment Previews

  • Changes array of object
    • BuildInformation array of object
    • Commits array of object
      Aggregate of distinct commits from all VersionMetadata.
    • ReleaseNotes string
    • Version string
    • WorkItems array of object
      Aggregate of distinct work items from all VersionMetadata.
  • ChangesMarkdown string
  • Form object
    • Elements array of object
      Elements of the form.
    • Values object
      Values supplied for the form elements.
  • Id string
    Gets or sets a unique identifier for this resource.
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • StepsToExecute array of object
    • ActionId string
    • ActionName string
    • ActionNumber string
    • AvailableTagSets array of object
    • CanBeSkipped boolean
    • ExcludedMachines array of object
    • HasNoApplicableMachines boolean
    • IsDisabled boolean
    • MachineNames array of string
    • Machines array of object
    • Roles array of string
    • UnavailableMachines array of object
  • UseGuidedFailureModeByDefault boolean

Example Request

JSON
{
  "DeploymentPreviews": [
    {
      "EnvironmentId": "Environments-1",
      "TenantId": "Tenants-1"
    }
  ],
  "IncludeDisabledSteps": true,
  "ReleaseId": "Releases-1",
  "SpaceId": "Spaces-1"
}

Example Response

JSON
[
  {
    "Changes": [
      {
        "BuildInformation": [
          {}
        ],
        "Commits": [
          {}
        ],
        "ReleaseNotes": "string",
        "Version": "string",
        "WorkItems": [
          {}
        ]
      }
    ],
    "ChangesMarkdown": "string",
    "Form": {
      "Elements": [
        {}
      ],
      "Values": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      }
    },
    "Id": "string",
    "LastModifiedBy": "string",
    "LastModifiedOn": "2020-01-01T00:00:00.000Z",
    "Links": {
      "additionalProp1": "string",
      "additionalProp2": "string",
      "additionalProp3": "string"
    },
    "StepsToExecute": [
      {
        "ActionId": "string",
        "ActionName": "string",
        "ActionNumber": "string",
        "AvailableTagSets": [
          {}
        ],
        "CanBeSkipped": true,
        "ExcludedMachines": [
          {}
        ],
        "HasNoApplicableMachines": true,
        "IsDisabled": true,
        "MachineNames": [
          "string"
        ],
        "Machines": [
          {}
        ],
        "Roles": [
          "string"
        ],
        "UnavailableMachines": [
          {}
        ]
      }
    ],
    "UseGuidedFailureModeByDefault": true
  }
]

Get the list of Packages that are missing from the built-in feed for a release

GET /api/{spaceId}/releases/{releaseId}/missingPackages

Also reachable at /api/spaces/{spaceIdentifier}/releases/{releaseId}/missingPackages.

Path Parameters

  • releaseId string (required)
  • spaceId string (required)

Response

200 — The list of Packages from the built-in feed missing for a Release.

  • Packages array of object
    • Id string
      Minimum length 1.
    • Version string
      Minimum length 1.

Example Response

JSON
{
  "Packages": [
    {
      "Id": "string",
      "Version": "string"
    }
  ]
}

Get all of the information necessary for creating or editing a deployment for this release

GET /api/{spaceId}/releases/{releaseId}/progression

Also reachable at /api/releases/{releaseId}/progression, /api/spaces/{spaceIdentifier}/releases/{releaseId}/progression.

Path Parameters

  • releaseId string (required)
    Id of the release.
  • spaceId string (required)
    The ID of the space containing the resource(s).

Response

200 — Lifecycle progression information necessary for creating or editing a deployment for a release

  • Id string
    Gets or sets a unique identifier for this resource.
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • NextDeployments array of string
  • NextDeploymentsMinimumRequired integer
  • Phases array of object
    • AutomaticDeploymentTargets array of string
    • Blocked boolean
    • Deployments array of object
    • Id string
    • IsOptionalPhase boolean
    • IsPriorityPhase boolean
    • MinimumEnvironmentsBeforePromotion integer
    • Name string
    • OptionalDeploymentTargets array of string
    • Progress enum
      Allowed values: Pending, Current, Complete.

Example Response

JSON
{
  "Id": "string",
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "NextDeployments": [
    "Environments-1",
    "..."
  ],
  "NextDeploymentsMinimumRequired": 0,
  "Phases": [
    {
      "AutomaticDeploymentTargets": [
        "Environments-1",
        "..."
      ],
      "Blocked": true,
      "Deployments": [
        {}
      ],
      "Id": "string",
      "IsOptionalPhase": true,
      "IsPriorityPhase": true,
      "MinimumEnvironmentsBeforePromotion": 0,
      "Name": "string",
      "OptionalDeploymentTargets": [
        "Environments-1",
        "..."
      ],
      "Progress": "Pending"
    }
  ]
}

Update the release notes on an existing Release

POST /api/{spaceId}/releases/{releaseId}/release-notes

Also reachable at /api/releases/{releaseId}/release-notes, /api/spaces/{spaceIdentifier}/releases/{releaseId}/release-notes.

Only the release notes are changed and everything else about the Release is left alone. Variable expressions in the notes are evaluated before they are stored, so the saved text is the resolved one.

Path Parameters

  • releaseId string (required)
    Id of the release.
  • spaceId string (required)
    The ID of the space containing the resource(s).

Request Body

  • ReleaseId string (required)
    The ID of the release, for example ‘Releases-123’.
  • ReleaseNotes string (required)
    The notes to store, replacing whatever the release currently has. Markdown is supported. Build information is in scope, so expressions such as #{Octopus.Release.WorkItems} and #{Octopus.Release.Number} are resolved before the notes are saved. Send an empty string to clear them.
  • SpaceId string (required)
    The ID of the space containing the resource(s).

Response

200 — Confirmation that the release notes were updated, containing the updated Release

  • Assembled string
    Format date-time.
  • BuildInformation array of object
    • Branch string
    • BuildEnvironment string
    • BuildNumber string
    • BuildUrl string
    • Commits array of object
    • IssueTrackerName string
    • PackageId string
    • VcsCommitNumber string
    • VcsCommitUrl string
    • VcsRoot string
    • VcsType string
    • Version string
    • WorkItems array of object
  • ChannelId string
  • CustomFields object
  • Id string
    Gets or sets a unique identifier for this resource.
  • IgnoreChannelRules boolean
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • LibraryVariableSetSnapshotIds array of string
    Snapshots of the project’s included library variable sets. The snapshots are VariableSetResources, not LibraryVariableSetResources.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • ProjectDeploymentProcessSnapshotId string
  • ProjectId string
  • ProjectVariableSetSnapshotId string
  • ReleaseNotes string
  • SelectedGitResources array of object
    • ActionName string
      Minimum length 1.
    • GitReferenceResource object
    • GitResourceReferenceName string
  • SelectedPackages array of object
    • ActionName string
    • PackageReferenceName string
    • StepName string
    • Version string
  • SpaceId string
  • VariableSnapshotConcurrencyToken string
    Identifies the release’s current variable snapshots.
  • Version string
    Maximum length 349.
  • VersionControlReference object
    • GitCommit string
    • GitRef string
    • VariablesGitCommit string

Example Request

JSON
{
  "ReleaseId": "Releases-1",
  "ReleaseNotes": "string",
  "SpaceId": "Spaces-1"
}

Example Response

JSON
{
  "Assembled": "2020-01-01T00:00:00.000Z",
  "BuildInformation": [
    {
      "Branch": "string",
      "BuildEnvironment": "string",
      "BuildNumber": "string",
      "BuildUrl": "string",
      "Commits": [
        {}
      ],
      "IssueTrackerName": "string",
      "PackageId": "string",
      "VcsCommitNumber": "string",
      "VcsCommitUrl": "string",
      "VcsRoot": "string",
      "VcsType": "string",
      "Version": "string",
      "WorkItems": [
        {}
      ]
    }
  ],
  "ChannelId": "Channels-1",
  "CustomFields": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "Id": "Releases-1",
  "IgnoreChannelRules": true,
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "LibraryVariableSetSnapshotIds": [
    "string"
  ],
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "ProjectDeploymentProcessSnapshotId": "string",
  "ProjectId": "Projects-1",
  "ProjectVariableSetSnapshotId": "string",
  "ReleaseNotes": "string",
  "SelectedGitResources": [
    {
      "ActionName": "string",
      "GitReferenceResource": {
        "GitCommit": "string",
        "GitRef": "string"
      },
      "GitResourceReferenceName": "string"
    }
  ],
  "SelectedPackages": [
    {
      "ActionName": "string",
      "PackageReferenceName": "string",
      "StepName": "string",
      "Version": "string"
    }
  ],
  "SpaceId": "Spaces-1",
  "VariableSnapshotConcurrencyToken": "string",
  "Version": "string",
  "VersionControlReference": {
    "GitCommit": "string",
    "GitRef": "string",
    "VariablesGitCommit": "string"
  }
}

Update the Variable Snapshot for a Release

POST /api/{spaceId}/releases/{releaseId}/snapshot-variables

Also reachable at /api/releases/{releaseId}/snapshot-variables, /api/spaces/{spaceIdentifier}/releases/{releaseId}/snapshot-variables.

Path Parameters

  • releaseId string (required)
  • spaceId string (required)

Request Body

  • ReleaseId string (required)
  • SpaceId string (required)
  • VariableSnapshotConcurrencyToken string
    The VariableSnapshotConcurrencyToken read from the release. When supplied, the update fails with a conflict if the release’s variable snapshots have changed since. Omit to skip the check.

Response

200 — Confirmation that the Variable Snapshot for a Release was updated, containing the updated Release

  • Assembled string
    Format date-time.
  • BuildInformation array of object
    • Branch string
    • BuildEnvironment string
    • BuildNumber string
    • BuildUrl string
    • Commits array of object
    • IssueTrackerName string
    • PackageId string
    • VcsCommitNumber string
    • VcsCommitUrl string
    • VcsRoot string
    • VcsType string
    • Version string
    • WorkItems array of object
  • ChannelId string
  • CustomFields object
  • Id string
    Gets or sets a unique identifier for this resource.
  • IgnoreChannelRules boolean
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • LibraryVariableSetSnapshotIds array of string
    Snapshots of the project’s included library variable sets. The snapshots are VariableSetResources, not LibraryVariableSetResources.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • ProjectDeploymentProcessSnapshotId string
  • ProjectId string
  • ProjectVariableSetSnapshotId string
  • ReleaseNotes string
  • SelectedGitResources array of object
    • ActionName string
      Minimum length 1.
    • GitReferenceResource object
    • GitResourceReferenceName string
  • SelectedPackages array of object
    • ActionName string
    • PackageReferenceName string
    • StepName string
    • Version string
  • SpaceId string
  • VariableSnapshotConcurrencyToken string
    Identifies the release’s current variable snapshots.
  • Version string
    Maximum length 349.
  • VersionControlReference object
    • GitCommit string
    • GitRef string
    • VariablesGitCommit string

Example Request

JSON
{
  "ReleaseId": "Releases-1",
  "SpaceId": "Spaces-1",
  "VariableSnapshotConcurrencyToken": "string"
}

Example Response

JSON
{
  "Assembled": "2020-01-01T00:00:00.000Z",
  "BuildInformation": [
    {
      "Branch": "string",
      "BuildEnvironment": "string",
      "BuildNumber": "string",
      "BuildUrl": "string",
      "Commits": [
        {}
      ],
      "IssueTrackerName": "string",
      "PackageId": "string",
      "VcsCommitNumber": "string",
      "VcsCommitUrl": "string",
      "VcsRoot": "string",
      "VcsType": "string",
      "Version": "string",
      "WorkItems": [
        {}
      ]
    }
  ],
  "ChannelId": "Channels-1",
  "CustomFields": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "Id": "Releases-1",
  "IgnoreChannelRules": true,
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "LibraryVariableSetSnapshotIds": [
    "string"
  ],
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "ProjectDeploymentProcessSnapshotId": "string",
  "ProjectId": "Projects-1",
  "ProjectVariableSetSnapshotId": "string",
  "ReleaseNotes": "string",
  "SelectedGitResources": [
    {
      "ActionName": "string",
      "GitReferenceResource": {
        "GitCommit": "string",
        "GitRef": "string"
      },
      "GitResourceReferenceName": "string"
    }
  ],
  "SelectedPackages": [
    {
      "ActionName": "string",
      "PackageReferenceName": "string",
      "StepName": "string",
      "Version": "string"
    }
  ],
  "SpaceId": "Spaces-1",
  "VariableSnapshotConcurrencyToken": "string",
  "Version": "string",
  "VersionControlReference": {
    "GitCommit": "string",
    "GitRef": "string",
    "VariablesGitCommit": "string"
  }
}